import java.applet.AudioClip;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.Graphics2D;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
public class Pelota implements EventoTimerListener {
Image im;
Pizarra pizarra;
double x, y,gra=0;
double angulo=0;
double alf=0.0,dalfa=0.0;int ide;
double sentidox,sentidoy=1.0,incrx=2.0,incry=2.0;

int vel;
Pelota colision=null;
	public Pelota(Pizarra piz, double xx,double yy,double dalf,double sentx,int id,int velo){
		pizarra=piz;sentidox=sentx;ide=id;
		x = xx; y = yy; dalfa=dalf;vel = velo;
		if((id/2)*2==id)im = cargarImagen("sphere.gif");
		else im = cargarImagen("baseball.gif");
		//Timer tiempo = new Timer(50);
		//tiempo.addEventoTimerListener(this, 1);
		pizarra.tiempo.addEventoTimerListener(this, vel);
	}
	public Image cargarImagen(String arch) {
		Image imagen = Toolkit.getDefaultToolkit().getImage(arch);;
		return imagen;
	}
public void dibujar(Graphics2D g){
	g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.0f)); 
	AffineTransform t = AffineTransform.getTranslateInstance(x,y);


	t.rotate(alf);
	t.translate(-24.0f,-24.0f);
	g.drawImage(im,t, pizarra);  
	g.setColor(Color.yellow);
	g.drawString(Integer.toString(ide),(int)x,(int)y);
} 
public double getX(){
	return x;
}
public double getY(){
	return y;
}
	public void ahora(int d){
  		Dimension dd = pizarra.getSize();
		alf=alf+dalfa*(double)sentidox*(double)sentidoy;
		double a=x,b=y;
		if(b<=28)sentidoy=1.0;
		if(b>=dd.height-28)sentidoy=-1.0;
		if(a<=28)sentidox=1.0;
		if(a>=dd.width-28)sentidox=-1.0;
		a=a+sentidox*incrx;
		b=b+sentidoy*incry;
		int dia = im.getWidth(pizarra);
		Pelota p;

		boolean bul = false;
		boolean detras = false;
		boolean arriba = false;
		colision=null;
		for(int i=0;i<pizarra.v.size();i++){
			p = (Pelota)pizarra.v.elementAt(i);
			if(p!=this){

			if(Math.abs(Math.sqrt((p.x-this.x)*(p.x-this.x)+(p.y-this.y)*(p.y-this.y))) < (double)dia){

				colision=p;
				if(p.colision!=this){
					double aa=p.dalfa;
					p.dalfa=dalfa;
					//dalfa=aa; 
				}
				bul = true;
				incrx = Math.abs(p.x - this.x) / 12.0;
				incry = Math.abs(p.y - this.y) / 12.0;
				if ((incrx == 0.0) && (incry == 0.0))		incrx = 1.0;
				if ((p.incrx == 0.0) && (p.incry == 0.0))   p.incrx = 1.0;
				if(p.x > x){detras=true;sentidox=-1.0;}
				else sentidox=1.0;
				if(p.y > y){arriba=true;sentidoy=-1.0;}
				else sentidoy=1.0;
			}
		} 
	}
			if (!bul || !detras) x=a;
			if (!bul || !arriba) y=b;
	}
}
