import java.applet.AudioClip;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.Graphics2D;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
public class Pelota implements EventoTimerListener {
Image im;
Pizarra pizarra;
int x, y,gra=0;
double alf=0.0,dalfa=0.0;
	public Pelota(Pizarra piz, int xx,int yy,double dalf){
		pizarra=piz;
		x = xx; y = yy; dalfa=dalf;
		im = cargarImagen("baseball.gif");
		Timer tiempo = new Timer(50);
		tiempo.addEventoTimerListener(this, 1);
	}
	public Image cargarImagen(String arch) {
		Image imagen = Toolkit.getDefaultToolkit().getImage(arch);;
		return imagen;
	}
public void dibujar(Graphics2D g){
	g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1.0f)); 
	AffineTransform t = AffineTransform.getTranslateInstance((double)x,(double)y);
	t.rotate(alf);
	t.translate(-24.0f,-24.0f);
	g.drawImage(im,t, pizarra);  
} 
public Point getXY(){
	
	Point p=new Point(x,y);
	return p;
}
	public void ahora(int d){
		alf=alf+dalfa;
		int a=x,b=y;
		if(b<200)b++;
		if(a<624)a++;
		else {
			if (b<500){b=b+gra;gra++;}
			else {a=0; b=20;gra=0;}
		}
		int dia = im.getWidth(pizarra);
		Pelota p;
		Point xy;
		boolean bul = false;
		boolean detras = false;
		for(int i=0;i<pizarra.v.size();i++){
			p = (Pelota)pizarra.v.elementAt(i);
			if(p!=this){
				xy=p.getXY();
				if(Math.abs(Math.sqrt((double)(xy.x-this.x)*(double)(xy.x-this.x)+(double)(xy.y-this.y)*(double)(xy.y-this.y))) <= (double)dia){
					bul = true;
					if(xy.x >x ) detras=true;
				}

			}
		}
		if (!bul || !detras ){ x=a; y=b;}
	}
}
