import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.awt.Graphics2D;
import java.awt.geom.*;
public class Canal extends Canvas implements EventoTimerListener{
	Vector v = new Vector();
	boolean paraLaDerecha;
	public EntidadPar TX;
	public EntidadPar RX;
	Visor visor;
	public Canal(boolean s){
		visor = new Visor();
		Pizarra.misma.add(visor);
		
		paraLaDerecha = s;
		this.setSize(400,22);
		this.setVisible(true);
		this.setBackground(Color.black);
		Pizarra.tiempo.addEventoTimerListener(this, 1);
if(paraLaDerecha)visor.setLocation(10,40);
else visor.setLocation(25,40);
	}

	public void agregarPdu(Pdu p){
		if(paraLaDerecha)
			p.set(-100,2,p.getN(),getSize());
		else
			p.set(getSize().width+1,2,p.getN(),getSize());
		v.add(p);
	}

	Image offImage;
    	Graphics offGraphics;
	Dimension offDimension;
	public synchronized void update(Graphics g){                                  

  		Dimension d = getSize();

     		if ( (offGraphics == null)
          		|| (d.width != offDimension.width)
          		|| (d.height != offDimension.height) ) {  
     	   			offDimension = d;
           			offImage = createImage(d.width, d.height);
           			offGraphics = offImage.getGraphics();
		}
 
        	//Borra las imagenes previas:
        	//offGraphics.setColor(getBackground());
		offGraphics.setColor(Color.blue);
       		offGraphics.fillRect(0,0,d.width,d.height);
		offGraphics.setColor(Color.green);
       		offGraphics.drawRect(0,0,d.width-1,d.height-1);
		Pdu p;
double ocup=0.0;
		for (int i=0;i<v.size();i++){
			p=(Pdu)v.get(i);
ocup=ocup+p.enCanal();
			p.dibujar(offGraphics);
			if (paraLaDerecha) {
				if(p.masX()){
					if (RX!=null)RX.recibe(p,this);
					v.remove(p);
				} else if (RX!=null)RX.recibiendo(p.masRX(),this);
			}
			else 	{
				if(p.menosX()){
					if (RX!=null)RX.recibe(p,this);
					v.remove(p);
				} else if (RX!=null)RX.recibiendo(p.menosRX(),this);
			}

		}
visor.nivel=(int)((ocup/400.0)*100.0);	
visor.update(visor.getGraphics());
		//offGraphics.setColor(Color.red);
		//offGraphics.drawRect(2,d.height-1,(int)ocup,2);
		g.drawImage(offImage, 0, 0, this);	
	} 
 	public void paint(Graphics g){
		update(g);
 	}
	public void ahora(int d){
		if(this.getGraphics()!=null)
			update(this.getGraphics());
	}

}
