import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.awt.Graphics2D;
import java.awt.geom.*;
public abstract class EntidadPar extends Canvas implements EventoTimerListener{
	Vector v = new Vector();
	public Canal TX;
	public Canal RX;
	boolean sentido;
	Pdu pd,rec;
	public int N=0,ACK=-1;
	int ritmo = 400;
	public EntidadPar(boolean s){
		sentido = s;
		this.setSize(120,120);
		this.setVisible(true);
		this.setBackground(Color.black);
		Pizarra.tiempo.addEventoTimerListener(this, 2);
		Pizarra.tiempo.addEventoTimerListener(this, 6);
	}

	public void agregarPdu(Pdu p){
		v.add(p);
	}

	Image offImage;
    	Graphics offGraphics;
	Dimension offDimension;
	public synchronized void update(Graphics g){                               

  		Dimension d = getSize();

     		if ( (offGraphics == null)
          		|| (d.width != offDimension.width)
          		|| (d.height != offDimension.height) ) {  
     	   			offDimension = d;
           			offImage = createImage(d.width, d.height);
           			offGraphics = offImage.getGraphics();
		}
 
        	//Borra las imagenes previas:
        	//offGraphics.setColor(getBackground());
		offGraphics.setColor(Color.blue);
       		offGraphics.fillRect(0,0,d.width,d.height);
		offGraphics.setColor(Color.green);
       		offGraphics.drawRect(0,0,d.width-1,d.height-1);
		Pdu p;
	for (int i=0;i<v.size();i++){
			p=(Pdu)v.get(i);
			p.dibujar(offGraphics);
		}
	if(rec!=null){
		rec.dibujar(offGraphics);
		rec=null;
	}
		g.drawImage(offImage, 0, 0, this);	
	} 
 	public void paint(Graphics g){
		update(g);
 	}
	public void ahora(int d){
		if(d==6){
			Pdu p;
			for (int i=0;i<v.size();i++){
				p=(Pdu)v.get(i);
				if (p.menosY()) v.remove(p);
			}
		} else {
		if(this.getGraphics()!=null)
			update(this.getGraphics());
		}
	}
	public void recibe(Pdu p, Canal cc){
		p.set(2,cc.getLocationOnScreen().y-getLocationOnScreen().y+2,p.getN(),getSize());
		v.add(p);
		ACK=p.getN();
		if(this instanceof Rx){
			if (N>=10)N=0;
			Pizarra.c1.agregarPdu(new Pdu(N,ACK,Pizarra.c1.getSize()));
			N++;
		}
	}
	public void recibiendo(Pdu p, Canal cc){
		int xx=0;
		if (p != null){
			if (p.getX()<0)xx=getSize().width+p.getX();
			else xx=p.getX()-cc.getSize().width;
			//rec = new Pdu(p.getN(),getSize());
			rec= p.duplica();
			rec.set(xx,cc.getLocationOnScreen().y-getLocationOnScreen().y+2,p.getN(),getSize());
		}
	}
	void enviarPdu(){
		if (N>=10)N=0;		
		TX.agregarPdu(new Pdu(N,ACK,TX.getSize()));
		N++;
	}

	public abstract void correr();
}
