import java.awt.event.*;
import java.awt.*;
import java.util.*;
public class Pizarra extends Frame implements MouseListener,MouseMotionListener{
	Figura figuraRaiz=null;
	double r=50.0;
	public Pizarra(){
		this.setLayout(null);
		this.setSize(600,500);
		this.setVisible(true);
		this.setBackground(Color.white);
		this.addMouseListener(this);
		this.addMouseMotionListener(this);
		hebra h = new hebra(this);
		h.start();
	}

	     public void mousePressed(MouseEvent e){
                int x=e.getX(); int y=e.getY(); int m = e.getModifiers();
		if (m==8) {figuraRaiz=null;r=20.0;repaint();return;}
		Figura nuevaFigura=null;
		if (m==16)nuevaFigura = new Figura(x,y,true,r);

		else if (m==4)nuevaFigura = new Figura(x,y,false,r);
		if (figuraRaiz == null)figuraRaiz = nuevaFigura;
		else  insertarDerecha(nuevaFigura);
		r=r+1.0;
		update(getGraphics());
	     } 
             public void mouseReleased(MouseEvent e){;} 
             public void mouseClicked(MouseEvent e){;} 
             public void mouseEntered(MouseEvent e){;} 
             public void mouseExited(MouseEvent e){;} 

             public void mouseMoved(MouseEvent e){;} 
             public void mouseDragged(MouseEvent e){
                int x=e.getX(); int y=e.getY(); int m = e.getModifiers();
		Figura nuevaFigura=null;
		if (m==16)nuevaFigura = new Figura(x,y,true,r);
		else if (m==4)nuevaFigura = new Figura(x,y,false,r);
		if (figuraRaiz == null)figuraRaiz = nuevaFigura;
		else  insertarDerecha(nuevaFigura);
		//r=r+1.0;
		update(getGraphics());
	     } 


	public void insertarDerecha(Figura f){
		Figura aux = figuraRaiz;
		while(aux.figuraDerecha!=null){
			aux=aux.figuraDerecha;
		}
		aux.figuraDerecha=f;
	}

	Image offImage;
    	Graphics offGraphics;
	Dimension offDimension;
	public synchronized void update(Graphics g){                                  

  		Dimension d = getSize();

     		if ( (offGraphics == null)
          		|| (d.width != offDimension.width)
          		|| (d.height != offDimension.height) ) {  
     	   			offDimension = d;
           			offImage = createImage(d.width, d.height);
           			offGraphics = offImage.getGraphics();
		}
 
        	//Borra las imagenes previas:
        	offGraphics.setColor(getBackground());
       		offGraphics.fillRect(0,0,d.width,d.height);
		Figura aux = figuraRaiz;
		while(aux!=null){
		aux.xY();
		aux=aux.figuraDerecha;
		}
		aux = figuraRaiz;
		while(aux!=null){
		aux.dibujar(offGraphics);
		aux=aux.figuraDerecha;
		}
		aux = figuraRaiz;
		while(aux!=null){
		aux.nuevoAlfa();
		aux=aux.figuraDerecha;
		}
		g.drawImage(offImage, 0, 0, this);
	} 


 public void paint(Graphics g){
	update(g);
 }

}
