import java.util.*;
import java.awt.*;
public final class Timer extends Thread implements Runnable { //(inicio)

    	public Thread animatorThread;
	int delay;
	int t=0;
	Vector v = new Vector();
	int fps;
//------------------------- INIT ---------------------------------
 Timer(int f) {
        fps = f;
        delay = (fps > 0) ? (1000 / fps) : 100;
	this.start();
}

//----------------------- START -----------------------------------
public void start() {
    	    if (animatorThread == null) {
                animatorThread = new Thread(this);
            }
            animatorThread.start();
}

//------------------------ RUN ------------------------------------
public void run() {
        Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
        while ((Thread.currentThread() == animatorThread)) {
	    
  	    llamarDivisor();
            try {
                Thread.sleep(delay);
            } catch (InterruptedException e) {break;}
        }
}
public void addEventoTimerListener(EventoTimerListener c, int d){
	DivisorDeTiempo dt, div=null;
	for(int i = 0;i<v.size();i++){
		dt=(DivisorDeTiempo)v.get(i);
		if (dt.esDivisor(d)){ div = dt; break;}		
	}
	if (div == null)div = new DivisorDeTiempo(d);
	v.add(div);
	div.addEventoTimerListener(c);
}


	void llamarDivisor(){
		DivisorDeTiempo  et;
		for(int i = 0;i<v.size();i++){
			et=(DivisorDeTiempo)v.get(i);
			et.ahora();
		}
	}
}

class DivisorDeTiempo { 
	int divisor = 1;
	Vector v = new Vector();
	int t = 1;
 	DivisorDeTiempo(int d) {
		divisor = d;
	}
	public boolean esDivisor(int d){
		if (divisor == d) return true;
		else return false;
	}
	public void ahora(){
		if (t >= divisor){ t=1; llamar();}
		else t++;		
	}
	public void addEventoTimerListener(EventoTimerListener c){
		v.add(c);
	}
	void llamar(){
		EventoTimerListener et;
		for(int i = 0;i<v.size();i++){
			et=(EventoTimerListener)v.get(i);
			et.ahora(divisor);
		}
	}
}
