import java.applet.AudioClip;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.Graphics2D;
import java.awt.event.*;
import java.awt.geom.*;


public class Pizarra extends Frame implements MouseListener {

	Pizarra(){
		addMouseListener(this);
	}
	      
	public Image cargarImagen(String arch) {
		Image imagen = Toolkit.getDefaultToolkit().getImage(arch);;
		return imagen;
	}


	public void mousePressed(MouseEvent e){
		int x=e.getX(); int y=e.getY(); 
		int c = e.getModifiers(); 
		Graphics2D g = (Graphics2D)getGraphics();
		Color col = new Color(1.0f, 0.0f,0.0f,0.5f);
		if (c == 4 ){ 
			Image im = cargarImagen("autito.gif");
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.1f));
			g.drawImage(im, x, y, this);  
		}
		else if (c==8) {
			g.setPaint(col);
			g.fillRect(x, y, 50, 50);
			Shape cuadrado = new Rectangle2D.Float((float)x,
						(float)y,
						100.0f,
						100.0f);
			Shape circulo = new Ellipse2D.Float((float)x,
						(float)y,
						100.0f,
						100.0f);
			Shape curva = new CubicCurve2D.Float(110.0f, 110.0f,
						(float)x, (float)y,
						100.0f, 300.0f,
						150.0f, 250.0f);
			g.draw(cuadrado);
			g.draw(curva);
			g.setStroke(new BasicStroke(5.0f,
						BasicStroke.CAP_SQUARE,
						BasicStroke.JOIN_MITER,
						10.0f,
						new float[]{12.0f,9.0f,3.0f,9.0f},
						0.0f));
			g.draw(circulo);
		}
		else {
			Image im = cargarImagen("baseball.gif");
			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.1f));
			g.drawImage(im, x, y, this);  
		}
	}
	public void mouseReleased(MouseEvent e){;}
	public void mouseClicked(MouseEvent e){
	              
	}
	public void mouseEntered(MouseEvent e){;}
	public void mouseExited(MouseEvent e){;}



}
